;***************************************************************************
;---------------------------------------------------------------------------
; setup_load_from_sram_menu:
;---------------------------------------------------------------------------
;***************************************************************************

setup_load_from_sram_menu:

	ld a,codeoverbank
	ld (current_rom_bank),a
	ld ($2666),a

	jp setup_load_from_sram_menu_over

;***************************************************************************
;---------------------------------------------------------------------------
; load_from_sram_poop_loop:
;---------------------------------------------------------------------------
;***************************************************************************

load_from_sram_menu_poop_loop:

	ld a,codeoverbank
	ld (current_rom_bank),a
	ld ($2666),a

	jp load_from_sram_menu_poop_over

;***************************************************************************
;---------------------------------------------------------------------------
; setup_delete_from_sram_menu:
;---------------------------------------------------------------------------
;***************************************************************************

setup_delete_from_sram_menu:

	ld a,codeoverbank
	ld (current_rom_bank),a
	ld ($2666),a

	jp setup_delete_from_sram_menu_over

;***************************************************************************
;---------------------------------------------------------------------------
; delete_from_sram_menu_poop_loop:
;---------------------------------------------------------------------------
;***************************************************************************

delete_from_sram_menu_poop_loop:

	ld a,codeoverbank
	ld (current_rom_bank),a
	ld ($2666),a

	jp delete_from_sram_menu_poop_over

;***************************************************************************
;---------------------------------------------------------------------------
; setup_save_to_sram_menu:
;---------------------------------------------------------------------------
;***************************************************************************

setup_save_to_sram_menu:

	ld a,codeoverbank
	ld (current_rom_bank),a
	ld ($2666),a

	jp setup_save_to_sram_menu_over

;***************************************************************************
;---------------------------------------------------------------------------
; save_to_sram_poop_loop:
;---------------------------------------------------------------------------
;***************************************************************************

save_to_sram_menu_poop_loop:

	ld a,codeoverbank
	ld (current_rom_bank),a
	ld ($2666),a

	jp save_to_sram_menu_poop_over

;***************************************************************************
;---------------------------------------------------------------------------
; setup_load_from_rom_menu:
;---------------------------------------------------------------------------
;***************************************************************************

setup_load_from_rom_menu:

	ld a,codeoverbank
	ld (current_rom_bank),a
	ld ($2666),a

	jp setup_load_from_rom_menu_over

;***************************************************************************
;---------------------------------------------------------------------------
; load_from_rom_poop_loop:
;---------------------------------------------------------------------------
;***************************************************************************

load_from_rom_menu_poop_loop:

	ld a,codeoverbank
	ld (current_rom_bank),a
	ld ($2666),a

	jp load_from_rom_menu_poop_over

;***************************************************************************
;***************************************************************************
;***************************************************************************
;***************************************************************************
;***************************************************************************

copy_name_from_rom:

_get_name:

	; store important stuff for later

	push bc
	push de

	; set our header bank

	ld a,musicbank00
	ld (current_rom_bank),a
	ld ($2666),a

	; get the song start bank into E

	ld hl,mus_song_bank_table
	add hl,bc

	ld e,(hl)

	; convert BC into word index

	sla c
;	rl b

	; get the song start address into HL

	ld hl,mus_song_address_table
	add hl,bc
	ld a,(hli)
	ld h,(hl)
	ld l,a

	; add the song name offset

	ld bc,$0007
	add hl,bc

	; set our source bank

	ld a,e
	ld (current_rom_bank),a
	ld ($2666),a

	; now copy

	pop de

_copy_name:

	ld a,h
	and $f0
	cp $80
	jr nz,_no_h_carry

	ld h,$40
	ld a,(current_rom_bank)
	inc a
	ld (current_rom_bank),a
	ld ($2666),a
	
_no_h_carry:
	ld a,(hl)
	cp $ff
	jr z,_done_this_one

	call copy_hl_de_vram
	inc b
	ld a,b
	cp 18
	jr nz,_copy_name

	ld a,codeoverbank
	ld (current_rom_bank),a
	ld ($2666),a

_done_this_one:

	ld a,$20
	sub b
	add a,e
	ld e,a
	ld a,d
	adc a,0
	ld d,a

	pop bc
	inc c
	ld a,c
	cp 24
	ret z
	cp mus_num_songs
	jr nz,_get_name
	ret

;***************************************************************************
;***************************************************************************
;***************************************************************************
;***************************************************************************

draw_rom_file_info:

	call get_rom_song_address_hl_bc_e
	inc bc
	ld d,0

	ld a,codeoverbank
	ld (current_rom_bank),a
	ld ($2666),a

	jp update_file_info_disp

;***************************************************************************

